/*
 * amdalloc-ext.h - Advanced memory allocator.
 * Prototypes of malloc implementation.
 *
 * Copyright (c) 2024 Advanced Micro Devices, Inc. All Rights Reserved.
 */
#ifndef __AMDALLOC_EXT_H_
#define __AMDALLOC_EXT_H_

__BEGIN_DECLS

/* Alloactes size byte memory */
extern void *malloc(size_t size);

/* Allocate nmemb chunks of  size bytes each, initialized to 0. */
extern void *calloc(size_t nmemb, size_t size);

/*
 * Re-allocate the previously allocated memory pointed by ptr,
 * making the new  block size bytes long.
 */
extern void *realloc(void *ptr, size_t size);

/* Free a block allocated by any of malloc, realloc or calloc. */
extern void free(void *ptr);

/*
 * Get the size of actual allocation if the block pointed by ptr
 * belongs to amdalloc-ext and 0 otherwise.
 */
extern size_t malloc_usable_size_ext(void *ptr);

__END_DECLS
#endif /* __AMDALLOC_EXT_H_ */

