#ifndef LLVM_TRANSFORMS_SCALAR_LOOPCHAIN_PRE_CLEANUP_H
#define LLVM_TRANSFORMS_SCALAR_LOOPCHAIN_PRE_CLEANUP_H

#include "llvm/IR/PassManager.h"
#include "llvm/IR/InstVisitor.h"

namespace llvm {

class PreLoopChainCleanupPass : public PassInfoMixin<PreLoopChainCleanupPass> {
public:
  PreservedAnalyses run(Module &M, ModuleAnalysisManager &AM);
};

class PreLoopChainCleanupPassVisitor : public InstVisitor<PreLoopChainCleanupPassVisitor> {
public:
  void visitCallInst(CallInst &CI);
};

class PreLoopChainLcRandCleanupPass : public PassInfoMixin<PreLoopChainCleanupPass> {
public:
  PreservedAnalyses run(Module &M, ModuleAnalysisManager &AM);
  bool runOnFunction(Function &F, FunctionAnalysisManager &AM);
};

} // namespace llvm

#endif // LLVM_TRANSFORMS_SCALAR_LOOPCHAIN_PRE_CLEANUP_H