//===- Transform/Utils/StructRelayoutUtils.h - StructRelayoutUtils Utils -------------===//
//
// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
// See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
//===----------------------------------------------------------------------===//
//
// This family of functions required in StructRelayout transforms
//
//===----------------------------------------------------------------------===//

#ifndef LLVM_TRANSFORMS_UTILS_ARRAYDFAUTILS_H
#define LLVM_TRANSFORMS_UTILS_ARRAYDFAUTILS_H

#include "llvm/Transforms/Utils/LoopUtils.h"
#include "llvm/Analysis/TargetLibraryInfo.h"

namespace llvm {

    bool hasSTyOperations(Loop* TheLoop);
    bool isFlatSTy(Type* STy);
    StructType *GetBaseSTyPtrTyAndIdLevel(Type *Ty, int &IdLevel);

} // end namespace llvm

#endif // LLVM_TRANSFORMS_UTILS_ARRAYDFAUTILS_H
