##===- DetectVectorLibrary.cmake ------------------------------------------===##
#
# Performs a try_run to determine if a vector library is available.
#
##===----------------------------------------------------------------------===##

#
# Performs a try_run to determine if libmvec-x86 is available
#

function(detect_libmvec_x86 variable)
    set(CMAKE_C_FLAGS -msse)
    try_run(HAVE_RUN_${variable} HAVE_COMPILE_${variable}
            ${CMAKE_BINARY_DIR}
            ${CMAKE_SOURCE_DIR}/cmake/modules/DetectLibmvecX86.c
            LINK_LIBRARIES -lmvec)

    if(HAVE_COMPILE_${variable} AND NOT (HAVE_RUN_${variable} STREQUAL  FAILED_TO_RUN))
        set(HAVE_LIBMVEC_X86 YES)
    else()
        set(HAVE_LIBMVEC_X86 NO)
        file(APPEND ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeError.log
             "Libmvec X86 vector math library availability check failed with the following output:\n${COMP_OUTPUT}\n${RUN_OUTPUT}")
    endif()
    set(${variable} ${HAVE_LIBMVEC_X86} PARENT_SCOPE)
    message(STATUS "Check libmvec X86 vector math library available: ${HAVE_LIBMVEC_X86}")

endfunction(detect_libmvec_x86)

# Add other vector libraries here...
